<template>
  <q-page padding>
    <div class="row q-pa-xl q-gutter-md justify-between items-stretch">
      <h4>Basiseigenschaften</h4>
      <q-checkbox left-label v-model="editable" label="Bearbeiten" />
      <template v-for="(value, name) in onlyBaseStats">
        <template>
          <display
            @changedValue="consumeValueChanged"
            :valueName="name"
            :value="value"
            :key="name"
            :editable="editable"/>
        </template>
      </template>
      <q-btn color="primary" icon="add" label="Skill/Attribut hinzufügen" @click="addSubDialog = !addSubDialog" />
    </div>

    <div class="row q-pa-md justify-start">

      <div class="col-auto col-sm-6 q-gutter-md q-pa-md justify-start self-start">
        <h4>Attribute</h4>
        <div class="row" v-for="attribute in character.attributes" :key="attribute.name">
          <attribute :key="attribute.name">
            <display
              @changedValue="consumeValueChanged"
              slot="display"
              :valueName="attribute.name"
              :value="attribute.value"
              :editable="editable"
              :subCategory="'attributes'"
              />
          </attribute>
        </div>

      </div>

      <div class="col-auto q-gutter-md col-sm-6 q-pa-md justify-start self-start">
        <h4>Skills</h4>
        <div class="row" v-for="skill in character.skills" :key="skill.name">
          <skill :key="skill.name">
            <display
              @changedValue="consumeValueChanged"
              slot="display"
              :valueName="skill.name"
              :value="skill.value"
              :editable="editable"
              :subCategory="'skills'" />
          </skill>
        </div>
      </div>
    </div>
    <div class="row q-pa-md justify-start">
      <div class="col-auto col-sm-6 q-gutter-md q-pa-md justify-start self-start">
        <h4>Inventory</h4>
        <inventory-item v-for="item in character.inventory" :key="item.name" :item="item"></inventory-item>
      </div>
      <div class="col-auto col-sm-6 q-gutter-md q-pa-md justify-start self-start">
        <h4>Spells</h4>
        <spell v-for="spell in character.spells" :key="spell.name" :spell="spell"></spell>
      </div>
    </div>
    <q-dialog
      v-model="addSubDialog">
      <q-card>
        <q-card-section class="row items-center">
          <q-avatar icon="add" color="primary" text-color="white" />
          <span class="q-ml-sm">Füge ein neues Attribut oder einen neuen Skill hinzu</span>
          <div id="modalInput">
            <q-input v-model="nProp.name" type="text" label="Name" />
            <q-input v-model.number="nProp.value" type="number" label="Wert" />
            <q-select
              filled
              v-model="nProp.subCategory"
              :options="subCategories"
              label="Wähle eine Subkategorie"
              style="width: 250px"
          />
          </div>
        </q-card-section>
        <q-card-actions align="right">
          <q-btn flat label="Abbrechen" color="primary" v-close-popup />
          <q-btn flat label="Fertig" color="primary" @click="consumeModalClick" v-close-popup />
        </q-card-actions>
      </q-card>
    </q-dialog>

  </q-page>
</template>

<script>
import { mapState, mapGetters } from "vuex";
import attribute from "../components/attribute.vue";
import skill from "../components/skill.vue";
import keyvaluedisplay from "../components/keyvaluedisplay.vue";
import inventoryItem from "../components/inventoryItem.vue";
import spell from "../components/spell.vue";

export default {
  components: {
    'display': keyvaluedisplay,
    'skill': skill,
    'attribute': attribute,
    'inventory-item': inventoryItem,
    'spell': spell
  },
  data () {
    return {
      ...mapState("characters", ["characters"]),
      editable: false,
      addSubDialog: false,
      nProp: {
        name: "",
        value: 0,
        subCategory: ''
      },
      subCategories: [
        'skills',
        'attributes'
      ]
    };
  },

  methods: {
    getId () {
      return this.$route.params.id;
    },

    consumeValueChanged (name, value, sub) {
      var payload = {
        'charId': this.character.id,
        'name': name,
        'value': value,
        'subCategory': sub
      }
      this.$store.commit('changeValue', payload);
      this.editable = false;
    },

    consumeModalClick() {
      var payload = {
        'charId': this.character.id,
        nProp: this.nProp
      }
      this.nProp = {
        name: "",
        value: 0,
        subCategory: ''
      }
      this.$store.commit('addSubValue', payload);
    }
  },
  computed: {
    character: function () {
      var char = this.$store.getters.characterById(this.getId());
      return char;
    },

    onlyBaseStats: function () {
      var onlyBase = {};
      var char = this.$store.getters.characterById(this.getId());
      console.log(char);
      Object.keys(char).forEach((key) => {
        if (key !== 'attributes' && key !== 'skills' && key !== 'inventory' && key !== 'spells') {
          onlyBase[key] = char[key];
        }
      })

      return onlyBase;
    }
  }
};
</script>

<style lang="sass">

</style>
